/*
-------------------------------------------------------------------------------
                                I   M   L   I   B
				       1.1
-------------------------------------------------------------------------------

This software is Copyright (C) 1998 By The Rasterman (Carsten Haitzler). I
accept no responsability for anythign this software may or may not do to
your system - you use it completely at your own risk. This software comes
under the LGPL and GPL licences. The library itself is LGPL (all software in
Imlib and gdk_imlib directories) see the COPYING and COPYING.LIB files for
full legal details.
*/

#ifndef CONVERT_PATH
#  define CONVERT_PATH "/usr/local/bin"
#endif

#ifndef NETPBM_PATH
#  define NETPBM_PATH  "/usr/local/bin"
#endif

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <time.h>                                                            
#include <sys/ipc.h>
#include <sys/shm.h>

#ifdef _HAVE_STRING_H
#include <string.h>
#elif _HAVE_STRINGS_H
#include <strings.h>
#endif

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <X11/extensions/XShm.h>
#include <X11/extensions/shape.h>
#include <X11/cursorfont.h>

#ifdef BUILTIN_JPEG
#include <jpeglib.h>
#endif
#ifdef BUILTIN_PNG
#include <png.h>
#endif
#ifdef BUILTIN_TIFF
#include <tiffio.h>
#endif
#ifdef BUILTIN_GIF
#include <gif_lib.h>
#endif

#define BYTE_ORD_24_RGB 0
#define BYTE_ORD_24_RBG 1
#define BYTE_ORD_24_BRG 2
#define BYTE_ORD_24_BGR 3
#define BYTE_ORD_24_GRB 4
#define BYTE_ORD_24_GBR 5

extern ImlibData *id;

void dirty_pixmaps(GdkImlibImage *im);
void dirty_images(GdkImlibImage *im);
void find_pixmap(GdkImlibImage *im, int width, int height, GdkPixmap **pmap, GdkBitmap **mask);
GdkImlibImage *find_image(char *file);
void free_pixmappmap(GdkPixmap *pmap);
void free_image(GdkImlibImage *im);
void flush_image(GdkImlibImage *im);
void add_image(GdkImlibImage *im, char *file);
void add_pixmap(GdkImlibImage *im, int width, int height);
void clean_caches();
void nullify_image(GdkImlibImage *im);

void _SplitID(char *file, char *id);
void _GetExtension(char *file, char *ext);
#ifdef BUILTIN_JPEG
unsigned char *_LoadJPEG(FILE *f, int *w, int *h);
#endif /* BUILTIN_JPEG */
#ifdef BUILTIN_PNG
unsigned char *_LoadPNG(FILE *f, int *w, int *h, int *t);
#endif /* BUILTIN_PNG */
#ifdef BUILTIN_TIFF
unsigned char *_LoadTIFF(char *f, int *w, int *h, int *t);
#endif /* BUILTIN_TIFF */
#ifdef BUILTIN_GIF
unsigned char *_LoadGIF(char *f, int *w, int *h, int *t);
#endif /* BUILTIN_GIF */
unsigned char *_LoadXPM(char *f, int *w, int *h, int *t);
unsigned char *_LoadPPM(FILE *f, int *w, int *h);
int ispnm(char *file);
int isjpeg(char *file);
int ispng(char *file);
int istiff(char *file);
int iseim(char *file);
int isgif(char *file);
int isxpm(char *file);

GdkPixmap *gdk_imlib_pixmap_foreign_new(gint width, gint height, gint depth, Pixmap pmap);

void calc_map_tables(GdkImlibImage *im);

void _PaletteAlloc(int num, int *cols);

